package com.schisandra.oss.application.controller;

import com.alibaba.fastjson.JSON;
import com.google.common.base.Preconditions;
import com.schisandra.oss.application.convert.SchisandraOssQiniuDTOConverter;
import com.schisandra.oss.application.dto.SchisandraOssQiniuDTO;
import com.schisandra.oss.common.entity.Result;
import com.schisandra.oss.domain.bo.SchisandraOssQiniuBO;
import com.schisandra.oss.domain.service.SchisandraOssQiniuDomainService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * 七牛云对象存储配置表 controller
 *
 * @author landaiqing
 * @since 2024-06-02 22:25:11
 */
@RestController
@RequestMapping("/oss/qiniu/")
@Slf4j
public class SchisandraOssQiniuController {

    @Resource
    private SchisandraOssQiniuDomainService schisandraOssQiniuDomainService;

    /**
     * 新增七牛云对象存储配置表
     */
    @RequestMapping("add")
    public Result<Boolean> add(@RequestBody SchisandraOssQiniuDTO schisandraOssQiniuDTO) {

        try {
            if (log.isInfoEnabled()) {
                log.info("SchisandraOssQiniuController.add.dto:{}", JSON.toJSONString(schisandraOssQiniuDTO));
            }
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getUserId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getBasePath(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getAccessKey(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getSecretKey(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getBucketName(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getRegion(), "使用的Region不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getUseHttpsDomains(), "空间相关上传管理操作是否使用 https , 默认 是不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getAccUpHostFirst(), "空间相关上传管理操作是否使用代理加速上传，默认 是不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getUseDefaultUpHostIfNone(), "使用 AutoRegion 时，如果从区域信息得到上传 host 失败，使用默认的上传域名上传，默认 是upload.qiniup.com,uploadz1.qiniup.com,upload-z2.qiniup.com,upload-na0.qiniup.com,upload-as0.qiniup.com不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getPutThreshold(), "如果文件大小大于此值则使用断点上传, 否则使用Form上传不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getConnectTimeout(), "连接超时时间 单位秒(默认10s)不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getWriteTimeout(), "写超时时间 单位秒(默认 0 , 不超时)不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getReadTimeout(), "回复超时时间 单位秒(默认30s)不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getDispatcherMaxRequests(), "底层HTTP库所有的并发执行的请求数量不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getDispatcherMaxRequestsPerHost(), "底层HTTP库对每个独立的Host进行并发请求的数量不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getConnectionPoolMaxIdleCount(), "底层HTTP库中复用连接对象的最大空闲数量不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getConnectionPoolMaxIdleMinutes(), "底层HTTP库中复用连接对象的回收周期（单位分钟）不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getRetryMax(), "上传失败重试次数不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getPartSize(), "分片大小,默认5MB不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getTaskNum(), "并发线程数,默认等于CPU的核数不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getStatus(), "状态不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getOpenAdvancedSetup(), "是否开启高级设置不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getCreatedBy(), "创建人不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getCreatedTime(), "创建时间不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getUpdateTime(), "更新时间不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getUpdateBy(), "更新人不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getIsDeleted(), "是否删除 0 未删除 1已删除不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getExtraJson(), "额外字段不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getCreateBucket(), "当桶不存在，是否创建不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getCheckBucket(), "启动检测桶，是否存在不能为空");
            SchisandraOssQiniuBO SchisandraOssQiniuBO = SchisandraOssQiniuDTOConverter.INSTANCE.convertDTOToBO(schisandraOssQiniuDTO);
            return Result.ok(schisandraOssQiniuDomainService.add(SchisandraOssQiniuBO));
        } catch (Exception e) {
            log.error("SchisandraOssQiniuController.register.error:{}", e.getMessage(), e);
            return Result.fail("新增七牛云对象存储配置表失败");
        }

    }

    /**
     * 修改七牛云对象存储配置表
     */
    @RequestMapping("update")
    public Result<Boolean> update(@RequestBody SchisandraOssQiniuDTO schisandraOssQiniuDTO) {

        try {
            if (log.isInfoEnabled()) {
                log.info("SchisandraOssQiniuController.update.dto:{}", JSON.toJSONString(schisandraOssQiniuDTO));
            }
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getUserId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getBasePath(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getAccessKey(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getSecretKey(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getBucketName(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getRegion(), "使用的Region不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getUseHttpsDomains(), "空间相关上传管理操作是否使用 https , 默认 是不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getAccUpHostFirst(), "空间相关上传管理操作是否使用代理加速上传，默认 是不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getUseDefaultUpHostIfNone(), "使用 AutoRegion 时，如果从区域信息得到上传 host 失败，使用默认的上传域名上传，默认 是upload.qiniup.com,uploadz1.qiniup.com,upload-z2.qiniup.com,upload-na0.qiniup.com,upload-as0.qiniup.com不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getPutThreshold(), "如果文件大小大于此值则使用断点上传, 否则使用Form上传不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getConnectTimeout(), "连接超时时间 单位秒(默认10s)不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getWriteTimeout(), "写超时时间 单位秒(默认 0 , 不超时)不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getReadTimeout(), "回复超时时间 单位秒(默认30s)不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getDispatcherMaxRequests(), "底层HTTP库所有的并发执行的请求数量不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getDispatcherMaxRequestsPerHost(), "底层HTTP库对每个独立的Host进行并发请求的数量不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getConnectionPoolMaxIdleCount(), "底层HTTP库中复用连接对象的最大空闲数量不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getConnectionPoolMaxIdleMinutes(), "底层HTTP库中复用连接对象的回收周期（单位分钟）不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getRetryMax(), "上传失败重试次数不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getPartSize(), "分片大小,默认5MB不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getTaskNum(), "并发线程数,默认等于CPU的核数不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getStatus(), "状态不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getOpenAdvancedSetup(), "是否开启高级设置不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getCreatedBy(), "创建人不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getCreatedTime(), "创建时间不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getUpdateTime(), "更新时间不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getUpdateBy(), "更新人不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getIsDeleted(), "是否删除 0 未删除 1已删除不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getExtraJson(), "额外字段不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getCreateBucket(), "当桶不存在，是否创建不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getCheckBucket(), "启动检测桶，是否存在不能为空");
            SchisandraOssQiniuBO schisandraOssQiniuBO = SchisandraOssQiniuDTOConverter.INSTANCE.convertDTOToBO(schisandraOssQiniuDTO);
            return Result.ok(schisandraOssQiniuDomainService.update(schisandraOssQiniuBO));
        } catch (Exception e) {
            log.error("SchisandraOssQiniuController.update.error:{}", e.getMessage(), e);
            return Result.fail("更新七牛云对象存储配置表信息失败");
        }

    }

    /**
     * 删除七牛云对象存储配置表
     */
    @RequestMapping("delete")
    public Result<Boolean> delete(@RequestBody SchisandraOssQiniuDTO schisandraOssQiniuDTO) {

        try {
            if (log.isInfoEnabled()) {
                log.info("SchisandraOssQiniuController.delete.dto:{}", JSON.toJSONString(schisandraOssQiniuDTO));
            }
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getUserId(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getBasePath(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getAccessKey(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getSecretKey(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getBucketName(), "不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getRegion(), "使用的Region不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getUseHttpsDomains(), "空间相关上传管理操作是否使用 https , 默认 是不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getAccUpHostFirst(), "空间相关上传管理操作是否使用代理加速上传，默认 是不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getUseDefaultUpHostIfNone(), "使用 AutoRegion 时，如果从区域信息得到上传 host 失败，使用默认的上传域名上传，默认 是upload.qiniup.com,uploadz1.qiniup.com,upload-z2.qiniup.com,upload-na0.qiniup.com,upload-as0.qiniup.com不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getPutThreshold(), "如果文件大小大于此值则使用断点上传, 否则使用Form上传不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getConnectTimeout(), "连接超时时间 单位秒(默认10s)不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getWriteTimeout(), "写超时时间 单位秒(默认 0 , 不超时)不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getReadTimeout(), "回复超时时间 单位秒(默认30s)不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getDispatcherMaxRequests(), "底层HTTP库所有的并发执行的请求数量不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getDispatcherMaxRequestsPerHost(), "底层HTTP库对每个独立的Host进行并发请求的数量不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getConnectionPoolMaxIdleCount(), "底层HTTP库中复用连接对象的最大空闲数量不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getConnectionPoolMaxIdleMinutes(), "底层HTTP库中复用连接对象的回收周期（单位分钟）不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getRetryMax(), "上传失败重试次数不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getPartSize(), "分片大小,默认5MB不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getTaskNum(), "并发线程数,默认等于CPU的核数不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getStatus(), "状态不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getOpenAdvancedSetup(), "是否开启高级设置不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getCreatedBy(), "创建人不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getCreatedTime(), "创建时间不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getUpdateTime(), "更新时间不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getUpdateBy(), "更新人不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getIsDeleted(), "是否删除 0 未删除 1已删除不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getExtraJson(), "额外字段不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getCreateBucket(), "当桶不存在，是否创建不能为空");
            Preconditions.checkNotNull(schisandraOssQiniuDTO.getCheckBucket(), "启动检测桶，是否存在不能为空");
            SchisandraOssQiniuBO schisandraOssQiniuBO = SchisandraOssQiniuDTOConverter.INSTANCE.convertDTOToBO(schisandraOssQiniuDTO);
            return Result.ok(schisandraOssQiniuDomainService.delete(schisandraOssQiniuBO));
        } catch (Exception e) {
            log.error("SchisandraOssQiniuController.delete.error:{}", e.getMessage(), e);
            return Result.fail("删除七牛云对象存储配置表信息失败");
        }

    }

}
